package org.xbib.event.yield.ops;

import org.xbib.event.yield.Advancer;
import org.xbib.event.yield.Traverser;
import org.xbib.event.yield.Yield;

import java.util.Spliterator;
import java.util.stream.Stream;

public class FromStream<U> implements Advancer<U>, Traverser<U> {

    private final Spliterator<U> upstream;

    public FromStream(Stream<U> data) {
        this.upstream = data.spliterator();
    }


    @Override
    public void traverse(Yield<? super U> yield) {
        upstream.forEachRemaining(yield::ret);
    }

    @Override
    public boolean tryAdvance(Yield<? super U> yield) {
        return upstream.tryAdvance(yield::ret);
    }
}
