package org.xbib.event.yield.primitives.dbl;

import org.xbib.event.yield.Yield;

/**
 * Equivalent to {@code DoubleConsumer} with a yield semantics.
 */
@FunctionalInterface
public interface DoubleYield extends Yield<Double> {
    void ret(double item);

    @Override
    default void ret(Double item) {
        this.ret((double) item);
    }
}
