package org.xbib.event.yield.primitives.intgr;

import org.xbib.event.yield.Yield;

/**
 * Equivalent to {@code IntConsumer} with a yield semantics.
 */
@FunctionalInterface
public interface IntYield extends Yield<Integer> {
    void ret(int item);

    @Override
    default void ret(Integer item) {
        this.ret((int) item);
    }
}
