package org.xbib.event.io.file;

import org.xbib.event.EventConsumer;
import org.xbib.event.bus.AllowConcurrentEvents;
import org.xbib.event.bus.Subscribe;
import org.xbib.event.timer.TestTimerEvent;

import java.io.IOException;
import java.time.Instant;
import java.util.logging.Level;
import java.util.logging.Logger;

public class TestFileFollowEventConsumer implements EventConsumer {

    private static final Logger logger = Logger.getLogger(TestFileFollowEventConsumer.class.getName());

    @Subscribe
    @AllowConcurrentEvents
    void onEvent(TestFileFollowEvent event) {
        logger.log(Level.INFO, "received filefollow event path = " + event.getPath() + " content = " + event.getContent());
    }

    @Override
    public void close() throws IOException {
    }
}
